#ifndef __COMPONENT_H
#define __COMPONENT_H

#include <hpcxx_rts.h>
#include "MyGlobalPointerPack.h"
#include "temp.h"
#include "Constants.h"
#include <string.h>
#include <HPCxx_GlobalPtr.h>
#include <HPCxx_String.h>
#include "Class.h"
#include "TestObj.h"
#include "CommonObj.h"
#include "HPCxx_Arrays.h"
#include "InputPort.h"
#include "CommonPort.h"
#include "hpcxx_byte.h"
#include "RMIRegistry.h"

class Component {
private:

  short sh;
  int i;
  long lo;
  char ch;
  float fl;
  double dou;
  HPCxx_String st;
  hpcxx_byte boolType;
  hpcxx_byte byt;
  Class classObject;
  TestObj testObj;
  HPCxx_Array<booleanType> boolArray;
  HPCxx_Array<hpcxx_byte> byteArray;
  HPCxx_Array<short> shortArray;
  HPCxx_Array<int> intArray;
  HPCxx_Array<long> longArray;
  HPCxx_Array<char> charArray;
  HPCxx_Array<float> floatArray;
  HPCxx_Array<double> doubleArray;
  HPCxx_Array<HPCxx_String> stringArray;
  HPCxx_Array<TestObj> testObjectArray;

  static int registerOnce;
  static void registerMethods();

public:
  Component();
  int putBool(hpcxx_byte b);
  hpcxx_byte getBool();
  int putByte(hpcxx_byte b);
  hpcxx_byte getByte();
  int putShort(short sho);
  short getShort();
  int putInt(int i);
  int getInt();
  int putLong(long lo);
  long getLong();
  int putChar(char c);
  char getChar();
  int putFloat(float flo);
  float getFloat();
  int putDouble(double dou);
  double getDouble();
  int putString(HPCxx_String str);
  HPCxx_String getString();
  int putClassObject(Class cl);
  Class getClassObject();
  int putObject(TestObj to );
  TestObj getObject();
  int putBoolArray(HPCxx_Array<booleanType> bArray);
  HPCxx_Array<booleanType> getBoolArray();
  int putByteArray(HPCxx_Array<hpcxx_byte> bytArray);
  HPCxx_Array<hpcxx_byte> getByteArray();
  int putShortArray(HPCxx_Array<short>) ;
  HPCxx_Array<short> getShortArray();
  int putIntArray(HPCxx_Array<int>) ;
  HPCxx_Array<int> getIntArray();
  int putLongArray(HPCxx_Array<long>) ;
  HPCxx_Array<long> getLongArray();
  int putCharArray(HPCxx_Array<char>) ;
  HPCxx_Array<char> getCharArray();
  int putFloatArray(HPCxx_Array<float>) ;
  HPCxx_Array<float> getFloatArray();
  int putDoubleArray(HPCxx_Array<double>) ;
  HPCxx_Array<double> getDoubleArray();
  int putStringArray(HPCxx_Array<HPCxx_String>) ;
  HPCxx_Array<HPCxx_String> getStringArray();
  int putObjectArray(HPCxx_Array<TestObj>) ;
  HPCxx_Array<TestObj> getObjectArray();
  MyHPCxx_GlobalPtr<InputPort> getInputPort();
  MyHPCxx_GlobalPtr<CommonPort> getCommonPort();
  int sendRemoteReference(HPCxx_GlobalPtr<InputPort> rem);
  static int registrationID()  { return COMPONENT_REGISTRATION_ID; }
  ~Component();

friend void hpcxx_pack(HPCxx_Buffer &buf, Component *t,int count);
friend void hpcxx_unpack(HPCxx_Buffer &buf, Component *t,int count);
  
};


#endif // COMPONENT_H

