#ifndef _HPCXX_ARRAYS_C__
#define _HPCXX_ARRAYS_C__

#include "HPCxx_Arrays.h"

template <class T>
HPCxx_Array<T> :: HPCxx_Array(HPCxx_Array<T> &source) {
    len = source.len;
    value = new T[len];
    for(int i=0; i<len; i++) {
      value[i] = source [i];
    }
    // value = source.value;
    rel = source.rel;
    source.rel = 1;
    type = source.type;
    FQNofObject = source.FQNofObject;
    //    cerr << "rel value being transferred\n";
  }

template <class T>
HPCxx_Array<T>& HPCxx_Array<T> :: operator=(HPCxx_Array<T> &source) {
    len = source.len;
    //    value = source.value;
    value = new T[len];
    for(int i=0; i<len; i++) {
      value[i] = source [i];
    }
    rel = 1;
    //    source.rel = 0;
    type = source.type;
    FQNofObject = source.FQNofObject;
    //    cerr << "rel value being transferred\n";
    return *this;
  }

template <class T>
void HPCxx_Array<T> :: displayArray() {
  cout << " --------HPCxx_Array :: displayArray() ------------ " << endl;
  for (int i=0 ; i < this->len; i++) {
    cout << "Element[" << i <<"]  " << value[i] << endl; 
  }
  cout << "--------------------------------------------------- " << endl;
}

template <class T>
HPCxx_Array<T> ::  ~HPCxx_Array() { 
//     if (rel == 1) {
// 	 cerr << "deleting array_value\n";
// 	 delete [] value; 
//     }
  }


template < class T >
void hpcxx_pack(HPCxx_Buffer &buffer, HPCxx_Array<T> *arr, int count) {
  
  for (int j = 0; j < count; j++) {
    
    hpcxx_byte *typeByte = new hpcxx_byte();
    typeByte->byte = arr->type;

    hpcxx_pack(buffer, typeByte, 1);

    int len = arr[j].len;
    hpcxx_pack(buffer, &len, 1);
	
    if (typeByte->byte == 18) {
      hpcxx_pack(buffer, &(arr->FQNofObject), 1);
    }

    if (len > 0) {
	 T *value = arr[j].value;
	 for (int i = 0; i < len; i++)
	   hpcxx_pack(buffer, &(value[i]), 1);
    }
  }
}

template < class T >
void hpcxx_unpack(HPCxx_Buffer &buffer, HPCxx_Array<T> *arr, int count) {

  for (int j = 0; j < count; j++) {
    hpcxx_byte *typeByte = new hpcxx_byte();
    hpcxx_unpack(buffer, typeByte, 1);
    arr->type = typeByte->byte;

    int len;
    hpcxx_unpack(buffer, &len, 1);
    arr[j].len = len;
    
    // if it is an array of references then
    // get the FQNofTheObject
    if(typeByte->byte == 18) {
      
      hpcxx_byte *two = new hpcxx_byte();
      hpcxx_unpack(buffer, two, 1);
      assert(two->byte == 2);
      
      int lengthOfFQN;
      hpcxx_unpack(buffer, &lengthOfFQN, 1);
           
      char *FQN = new char[lengthOfFQN + 1];
      hpcxx_unpack(buffer, FQN, lengthOfFQN);
      FQN[lengthOfFQN] = '\0';
      
      arr->FQNofObject = *(new HPCxx_String(FQN));
    }
    if (len > 0) {
	 arr[j].value = new T[len];  
	 for (int i = 0; i < len; i++)
	   hpcxx_unpack(buffer, &(arr[j].value[i]), 1);
	 arr[j].rel = 1;
    }
  }
}

#endif //  _HPCXX_ARRAYS_C__




