#ifndef _RMI_REGISTRY_C__
#define _RMI_REGISTRY_C__

#include "RMIRegistry.h"
#include "temp.h"

template <class T>
RMIRegistry<T> :: RMIRegistry() {

   nexus_startpoint_t localStartpoint; 
   nexus_endpoint_t  *localEndpoint;
   localEndpoint = hpcxx_get_ep(); 
   nexus_startpoint_bind(&localStartpoint, localEndpoint);
   int bindID = hpcxx_register(&RMIRegistry<T>::bindRegistry, 102);
}


template <class T>
int RMIRegistry<T> :: attachToRegistry(char *registryHost, unsigned short port) {

  printf("\n RMIRegistry::attach_to_registry(): URL = (%s:%d) \n",registryHost, port);
  char *host = strdup(registryHost);
  int rc = hpcxx_grabContext(&registryStartpoint, host, port);
  printf("\n hpcxx_grabContext:  succeeded \n ");
  if (rc != 0){
    printf(" \n server-->attach_to_registry(): ERROR: failed with rc=%d\n", rc);
  }
  return SUCCESS;
}

template <class T>
int RMIRegistry<T> :: bindRegistry(MyHPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN) {
  dummy d;
  int result;
  HPCxx_GlobalPtr<dummy> remoteGP(&d, &registryStartpoint);
  HPCxx_GlobalRefImpl<T> &r = *gp;
  nexus_startpoint_t remoteObjStartpoint;
  nexus_startpoint_copy(&remoteObjStartpoint , r.contextID_);
  
  BindObject bindObject(rmiURL, FQN, localStartpoint, remoteObjStartpoint);
    
  //    HPCxx_GlobalPointer<RMIRegistry> 
  cout << "RMIRegistry:;bindRegistry(): hpcxx_minvoke() "  << endl;
  hpcxx_minvoke(&remoteGP, result, BIND_FID, bindObject);
  cout << "RMIRegistry:;bindRegistry(): hpcxx_minvoke() ... returned " << endl;
    
  return SUCCESS;
}

template <class T>
int RMIRegistry<T> :: rebindRegistry(MyHPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN) {
  dummy d;
  int result;
  HPCxx_GlobalPtr<dummy> remoteGP(&d, &registryStartpoint);
  HPCxx_GlobalRefImpl<T> &r = *gp;
  nexus_startpoint_t remoteObjStartpoint;
  nexus_startpoint_copy(&remoteObjStartpoint , r.contextID_);
  
  BindObject bindObject(rmiURL, FQN, localStartpoint, remoteObjStartpoint);
    
  //    HPCxx_GlobalPointer<RMIRegistry> 
  cout << "RMIRegistry:;bindRegistry(): hpcxx_minvoke() "  << endl;
  hpcxx_minvoke(&remoteGP, result, REBIND_FID, bindObject);
  cout << "RMIRegistry:;bindRegistry(): hpcxx_minvoke() ... returned " << endl;
    
  return SUCCESS;
}

template <class T>
RMIRegistry<T> :: ~RMIRegistry() {
// empty destructor
}

template <class T>
void hpcxx_pack(HPCxx_Buffer &buf, RMIRegistry<T> *t,int count) {}
template <class T>
void hpcxx_unpack(HPCxx_Buffer &buf, RMIRegistry<T> *t,int count) {}

#endif // _RMI_REGISTRY_C__







