
#include "TestObj.h"
#include <strings.h>


TestObj :: TestObj(int ii) {
  this->i = ii;
}

TestObj :: TestObj() {
  this->i = 0;
}

int TestObj :: getI() {
  return this->i;
}

  
ostream &operator<<(ostream  &output, TestObj  &testObj) {
  output << "TestObj<int i = " << testObj.i << "> "  << endl;
  return output;
}


TestObj :: ~TestObj() {
  // empty destructor
}



void hpcxx_pack(HPCxx_Buffer& b, TestObj* t, int i) {
  for (int j = 0; j < i; j++) {
    if (t->emptyObject == 1) {
      hpcxx_byte *zero = new hpcxx_byte();
      zero->byte = 0;
      hpcxx_pack(b, zero, 1);
    } else {

      // It is a non final object
      hpcxx_byte *twenty = new hpcxx_byte();
      twenty->byte = 20;
      hpcxx_pack(b, twenty, 1);
      
      // pack the FQN of this object
      char *FQN = "rmitest.TestObj";
      int lengthOfFQN = strlen(FQN);

      hpcxx_byte *two = new hpcxx_byte();
      two->byte = 2;
      hpcxx_pack(b, two, 1);
      hpcxx_pack(b, &lengthOfFQN , 1);
      hpcxx_pack(b, FQN , lengthOfFQN);
      
      // pack the internal state of the object
      hpcxx_pack(b, &(t->i), 1);
    }
  }
}

void hpcxx_unpack(HPCxx_Buffer& b, TestObj* s, int i) {
  for (int j = 0; j < i; j++) {
    
    // NexusRMI packs in the following format
    // byte 0: if the object is null and nothing else for this object
    // byte 20: indicates a non final object
    // int length: length of FQN of the object on the java side
    // all the charactes of the string
    // internal state of the object
    
    hpcxx_byte *whichByte = new hpcxx_byte();
    hpcxx_unpack(b, whichByte, 1);

    switch(whichByte->byte) {
    case 0: {
      s->emptyObject = 1;
      break;
    } case 20: {
      s->emptyObject = 7; // not an emtpy object, any int but 1 will do

      // receive the FQN (string) as a final object

      hpcxx_byte *two = new hpcxx_byte();
      hpcxx_unpack(b, two, 1);

      int lengthOfFQN;
      hpcxx_unpack(b, &lengthOfFQN, 1);

      char *FQN = new char[lengthOfFQN + 1];
      hpcxx_unpack(b, FQN, lengthOfFQN);
      FQN[lengthOfFQN] = '\0';

      // internal state of the object
      int variableI;
      hpcxx_unpack(b, &variableI, 1);
      s->i = variableI;
      
      break;
    } default:{
      printf("\n Error: TestObj.C::unpack(): Expecting byte 0 for null object or byte 20 for nonFinalObject. Byte %d Undefined \n", whichByte->byte);
      break;
    }
    }
  }
}
