package rmitest;

import java.net.*;
import nexusrmi.*;
import nexusrmi.server.*;
import nexusrmi.registry.*;

public class ServerImpl extends UnicastRemoteObject implements Server
{
  private static  int PORT = 7000; // default port
  
  private boolean[] BoolArray = {true, false, true};
  private byte[] ByteArray = {12, 34, 56, 78};
  private short[] ShortArray = {123, 456, 789};
  private int[] IntArray = {1234, 3456, 5678};
  private long[] LongArray = {12345, 45678};
  private char[] CharArray = {'!', '@', '#', '$', '%', '^', '&', '*'};
  private float[] FloatArray = {12.34f, 34.56f, 56.78f};
  private double[] DoubleArray = {12.3456, 34.5678};
  private String[] StringArray = {"Fabian", "Madhu", "Dennis"};
  private TestObj[] ObjectArray = { new TestObj(13), null,  new TestObj(7) };
  private int SUCCESS = 7;

    
  public ServerImpl() throws RemoteException
  {
    super();
  }
  
    public ServerImpl(Serialize ser) throws RemoteException
    {
	super(ser);
    }
    
    public void putBool(boolean b) throws RemoteException
    {
	System.out.println("putBool(): " + b);
    }
    
    public boolean getBool() throws RemoteException
    {
	return true;
    }
    
    public void putByte(byte b) throws RemoteException
    {
	System.out.println("putByte(): " + b);
    }
    
    public byte getByte() throws RemoteException
    {
	return (byte)12;
    }

    public void putShort(short s) throws RemoteException
    {
	System.out.println("putShort(): " + s);
    }
    
    public short getShort() throws RemoteException
    {
	return (short)123;
    }

    public void putInt(int i) throws RemoteException
    {
	System.out.println("putInt(): " + i);
    }
    
    public int getInt() throws RemoteException
    {
	return 1234;
    }

    public void putLong(long l) throws RemoteException
    {
	System.out.println("putLong(): " + l);
    }
    
    public long getLong() throws RemoteException
    {
	return 12345;
    }

    public void putChar(char c) throws RemoteException
    {
	System.out.println("putChar(): " + c);
    }
    
    public char getChar() throws RemoteException
    {
	return '#';
    }
    
    public void putFloat(float f) throws RemoteException
    {
	System.out.println("putFloat(): " + f);
    }
    
    public float getFloat() throws RemoteException
    {
	return 12.34f;
    }

    public void putDouble(double d) throws RemoteException
    {
	System.out.println("putDouble(): " + d);
    }
    
    public double getDouble() throws RemoteException
    {
	return 12.3456;
    }

    public void putString(String s) throws RemoteException
    {
	if(s == null)
	    System.out.print("null");
	else
	    System.out.println("putString(): " + s);
    }
    
    public String getString() throws RemoteException
    {
	return "server";
    }

    public void putClassObject(Class c) throws RemoteException
    {
	if(c == null)
	    System.out.print("null");
	else
	    System.out.println("putClassObject(): " + c);
    }
    
    public Class getClassObject() throws RemoteException
    {
	Class res = null;
	try
	{
	    res = Class.forName("java.lang.Object");
	}
	catch(ClassNotFoundException e)
	{
	    e.printStackTrace();
	}
	return res;
    }

    public void putObject(Object to) throws RemoteException
    {
	if(to == null)
	    System.out.println("putObject(): null");
	else
	    System.out.println("putObject(): " + ((TestObj)to).i);
    }
    
    public TestObj getObject() throws RemoteException
    {
	return new TestObj(56);
    }
    
    public void putBoolArray(boolean[] ba) throws RemoteException
    {
	System.out.print("putBoolArray(): [");
	if(ba == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < ba.length; i++)
		System.out.print(ba[i] + " ");
	System.out.println("]");
    }
    
    public boolean[] getBoolArray() throws RemoteException
    {
	return BoolArray;
    }
    
    public void putByteArray(byte[] ba) throws RemoteException
    {
	System.out.print("putByteArray(): [");
	if(ba == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < ba.length; i++)
		System.out.print(ba[i] + " ");
	System.out.println("]");
    }
    
    public byte[] getByteArray() throws RemoteException
    {
	return ByteArray;
    }

    public void putShortArray(short[] sa) throws RemoteException
    {
	System.out.print("putShortArray(): [");
	if(sa == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < sa.length; i++)
		System.out.print(sa[i] + " ");
	System.out.println("]");
    }
    
    public short[] getShortArray() throws RemoteException
    {
	return ShortArray;
    }

    public void putIntArray(int[] ia) throws RemoteException
    {
	System.out.print("putIntArray(): [");
	if(ia == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < ia.length; i++)
		System.out.print(ia[i] + " ");
	System.out.println("]");
    }
    
    public int[] getIntArray() throws RemoteException
    {
	return IntArray;
    }

    public void putLongArray(long[] la) throws RemoteException
    {
	System.out.print("putLongArray(): [");
	if(la == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < la.length; i++)
		System.out.print(la[i] + " ");
	System.out.println("]");
    }
    
    public long[] getLongArray() throws RemoteException
    {
	return LongArray;
    }
    
    public void putCharArray(char[] ca) throws RemoteException
    {
	System.out.print("putCharArray(): [");
	if(ca == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < ca.length; i++)
		System.out.print(ca[i] + " ");
	System.out.println("]");
    }
    
    public char[] getCharArray() throws RemoteException
    {
	return CharArray;
    }

    public void putFloatArray(float[] fa) throws RemoteException
    {
	System.out.print("putFloatArray(): [");
	if(fa == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < fa.length; i++)
		System.out.print(fa[i] + " ");
	System.out.println("]");
    }
    
    public float[] getFloatArray() throws RemoteException
    {
	return FloatArray;
    }

    public void putDoubleArray(double[] da) throws RemoteException
    {
	System.out.print("putDoubleArray(): [");
	if(da == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < da.length; i++)
		System.out.print(da[i] + " ");
	System.out.println("]");
    }
    
    public double[] getDoubleArray()throws RemoteException
    {
	return DoubleArray;
    }

    public void putStringArray(String[] sa) throws RemoteException
    {
	System.out.print("putStringArray(): [");
	if(sa == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < sa.length; i++)
		System.out.print(sa[i] + " ");
	System.out.println("]");
    }
    
    public String[] getStringArray() throws RemoteException
    {
	return StringArray;
    }

    public void putObjectArray(TestObj[] toa) throws RemoteException
    {
	System.out.print("putObjectArray(): [");
	if(toa == null)
	    System.out.print("null");
	else
	    for(int i = 0; i < toa.length; i++)
		if(toa[i] == null)
		    System.out.print("null");
		else
		    System.out.print(toa[i].i + " ");
	System.out.println("]");
    }
    
    public TestObj[] getObjectArray() throws RemoteException
    {
	return ObjectArray;
    }

  public InputPortInterface getInputPort() throws RemoteException  {
    InputPortInterface inputPort = new InputPort();
    return inputPort;
  }
  public InputPortInterface getCommonPort() throws RemoteException  {
    InputPortInterface commonPort = new CommonPort();
    return commonPort;
  }

  public int sendRemoteReference(InputPortInterface rem) throws RemoteException {
    System.out.println("\n ServerImpl:: received RemoteReference to InputPort ");
    System.out.println("\n ServerImpl:remoteRef.setHello<ServerImpl::rem.setHello>" );
    int result = rem.setHello("ServerImpl::rem.setHello");
    System.out.println("\n ServerImpl:remoteRef.sayHello() ");
    String resString = rem.sayHello();
    System.out.println("\n ServerImpl:remoteRef.sayHello() " + resString);
    return SUCCESS;
  }


  
    public static void main(String args[])   {
      if (args.length !=2) {
	System.out.println (" \nError ... \n");
	System.out.println("\n nexusrmitest.ServerImpl <registryHost> <PORT> ");
      }
    PORT = Integer.parseInt(args[1]);
      System.setSecurityManager(new RMISecurityManager());
	try    {
	  //   if(LocateRegistry.getRegistry() == null)
	  LocateRegistry.createRegistry(PORT);
	  
	    ServerImpl obj1 = new ServerImpl(new Nexusize());
	    //	    ServerImpl obj1 = new ServerImpl(new VerboseNexusize());

	    System.out.println("\n ServerImpl: binding on host: " +InetAddress.getLocalHost().getHostName() + ":" + PORT);
	    
	    Naming.bind("rmi://" + InetAddress.getLocalHost().getHostName() + ":" + PORT + "/Server", obj1);
	    System.out.println("Remote object " + obj1 + " bound in registry as : " + "Server");
// 	    ServerImpl obj2 = new ServerImpl(new CodedNexusize());
// 	    ServerImpl obj2 = new ServerImpl();
	    // 	    Naming.bind("rmi://" + InetAddress.getLocalHost().getHostName() + ":" + PORT + "/CodedServer", obj2);
	    // 	    System.out.println("Remote object " + obj2 + " bound in registry.");
	}
	catch(Exception e) {
	    e.printStackTrace();
	    System.exit(1);
	}
    }
}
